------------------------------------------------------------------------
--
-- t@C : loadmod.vhd
-- @\       : ׃W[
--              4rbgCftHg2048i̐[pCvC
--              \d͂҂
-- XV   : 2006/11/11 - ver 1.0  
--
-- Copyright(C)2006 K.Ochiai. All rights reserved.
--
------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

-------------------------
-- GeBeB
-------------------------
entity loadmod is
generic(
		DEPTH	: integer := 2048					-- pCvC[(ftHg2048i)
); 
port(
		CLK		: in std_logic;						-- NbN
		CKE		: in std_logic;						-- NbNECl[u
		RST		: in std_logic;						-- 񓯊Zbg
		LOAD	: in std_logic;						-- [hM
		LDATA	: in std_logic_vector(3 downto 0);	-- [hEf[^
		PIN		: in std_logic;						-- ĩp^[
		TDETECT	: out std_logic						-- gOo
);
end loadmod;

-------------------------
-- A[LeN`
-------------------------
architecture rtl of loadmod is
-- WX^/M`
signal reg0 	: std_logic_vector(DEPTH-1 downto 0);	-- pCvCErbg0
signal reg1 	: std_logic_vector(DEPTH-1 downto 0);	-- pCvCErbg1
signal reg2 	: std_logic_vector(DEPTH-1 downto 0);	-- pCvCErbg2
signal reg3 	: std_logic_vector(DEPTH-1 downto 0);	-- pCvCErbg3
signal reg_sft	: std_logic_vector(1 downto 0);			-- gOopVtgWX^

-- A[LeN`{
begin

	-- ׃ubN(pCvC)
	process(CLK,RST)
	variable n : integer;
	begin
		if(RST = '1') then							-- Zbg
			for n in 0 to DEPTH-1 loop
				reg0(n) <= '0';
				reg1(n) <= '0';
				reg2(n) <= '0';
				reg3(n) <= '0';
			end loop;
		elsif(CLK'event and CLK = '1') then			-- NbNオ蓯
			if(CKE = '1') then						-- @NbNECl[u'1'̂Ƃȉ̉H삷
				if(LOAD = '1') then					-- [h
					reg0(0) <= LDATA(0);			--   H̍œKɂpCvCk}~邽߂
					reg1(0) <= LDATA(1);			--   [h@\tĂD@\͎̂gȂ̂ŁC
					reg2(0) <= LDATA(2);            --   {[h̖gp[qɐM蓖āCFPGÃEB[NE
					reg3(0) <= LDATA(3);			--   vAbvŔANeBuɌŒ肷D
				else
					reg0(0) <= PIN;					-- pCvCiւ̃p^[
					reg1(0) <= PIN;
					reg2(0) <= PIN;
					reg3(0) <= PIN;
				end if;
				
				-- pCvC
				--   \[Xgpグ邽߁CtbvEtbvO4LUTKt悤Ș_ɂĂD
				--   ܂œKh߁Cerbg̘_͏ςĂD[h͎g킸Ci
                --   Mׂ͂ēȂ̂ŁĈ͂̃VtgWX^Ƃē삷D
				for n in 1 to DEPTH-1 loop
					reg0(n) <= (    reg0(n-1) and     reg1(n-1) and     reg2(n-1) and     reg3(n-1)) or
					           (not reg0(n-1) and     reg1(n-1) and not reg2(n-1) and     reg3(n-1));
					reg1(n) <= (    reg0(n-1) and     reg1(n-1) and     reg2(n-1) and     reg3(n-1)) or
					           (    reg0(n-1) and not reg1(n-1) and not reg2(n-1) and     reg3(n-1));
					reg2(n) <= (    reg0(n-1) and     reg1(n-1) and     reg2(n-1) and     reg3(n-1)) or
					           (not reg0(n-1) and     reg1(n-1) and     reg2(n-1) and not reg3(n-1));
					reg3(n) <= (    reg0(n-1) and     reg1(n-1) and     reg2(n-1) and     reg3(n-1)) or
					           (    reg0(n-1) and not reg1(n-1) and     reg2(n-1) and not reg3(n-1));
				end loop;
			end if;
		end if;
	end process;

	-- gOo
	process(CLK,RST)
	begin
		if(RST = '1') then							-- Zbg
			reg_sft <= (others => '0');
		elsif(CLK'event and CLK = '1') then			-- NbNオ蓯
			-- pCvCŏIi̐M܂Ƃ߂ăVtgWX^ɒʂ
			reg_sft(0) <= reg3(DEPTH-1) and reg2(DEPTH-1) and reg1(DEPTH-1) and reg0(DEPTH-1);
			reg_sft(1) <= reg_sft(0);
		end if;
	end process;
	-- pCvCŏIi̗オ/藼GbWoďo͂
	TDETECT <= '1' when reg_sft = "01" or reg_sft = "10" else '0';

end rtl;
